#ifndef SUDOKU_HPP
#define SUDOKU_HPP

#include <string>
#include <vector>

class Sudoku {
public:
    Sudoku(void);
    std::vector< std::vector<int> > board;
    void FillBoard(std::string filePath);
    void Solve(void);
    bool IsBoardSolved(void);
    void Print(void);
private:
    bool _Solve(void);
    bool FindEmptyCell(int* column, int* row);
    bool IsValidPlacement(int column, int row, int box);
    bool IsRowComplete(int row);
    bool IsColumnComplete(int column);
    std::vector<int> GetUnusedRow(int row);
    std::vector<int> GetUnusedColumn(int column);
    std::vector<int> GetUnusedSubgrid(int column, int row);
};

#endif
